{ Copyright (C) 1997 Wolfgang J Moeller. All rights reserved. NO WARRANTY! }

unit nds_util;
 
{ NDFP server utility routines
{
{ w.j.m. jan 1997 ff.
}

interface uses dsk_cio;


function io_failed(s: string): boolean;

function dos_sts(s: string): word;

function path2dsk(path: string; var drv: dsk_t_dev): word;
function dsk2sts(s: string; ds: dsk_t_sts): word;


implementation uses dos,nd_const;


function io_failed(s: string): boolean;
var
	ios: integer;
begin
	ios := ioresult;
	if ios <> 0 then begin
		writeln('??? IOresult ',ios,' * ',s);
		io_failed := true;
	end else
		io_failed := false;
end;

function dos_sts(s: string): word;
var
	dose: word;
begin
	dose := doserror; doserror := 0;
	if dose <> 0 then begin
		write('??? DOSerror ',dose);
		case dose of
		  2: begin
			dos_sts := NDSS_FNF;
			write(' (file not found)');
			end;
		  3: begin
			dos_sts := NDSS_IVPATH;
			write(' (directory not found)');
			end;
		  5: begin
			dos_sts := NDSS_NOACCESS;
			write(' (access denied)');
			end;
		else
			dos_sts := NDSS_DOSFAIL;
		end;
		writeln(' * ',s);
	end else
		dos_sts := NDSS_OK;
end;

function path2dsk(path: string; var drv: dsk_t_dev): word;
begin
	if length(path) <> 1 then begin
		path2dsk := NDSS_IVDATALEN;
		exit;	
	end;
	case path[1] of
	  'A','B','a','b': drv.devcls := dsk_k_fd;
	  'C'..'Z','c'..'z': drv.devcls := dsk_k_hd;
	  else begin
		path2dsk := NDSS_IVPARAM;
		exit;
	  end;
	end;
	case path[1] of
	  'A','a': drv.unitno := 0;
	  'B','b': drv.unitno := 1;
	  'C'..'Z': drv.unitno := ord(path[1]) - ord('C');
	  'c'..'z': drv.unitno := ord(path[1]) - ord('c');
	end;
	path2dsk := NDSS_OK;
end;

function dsk2sts(s: string; ds: dsk_t_sts): word;
begin
	if ds <> dsksts_ok then begin
		write('??? DSK error ',ds);
		case ds of
	 	  dsksts_erd: begin
			write(' (read error)');
			dsk2sts := NDSS_READERR;
			end;
	 	  dsksts_ewr: begin
			write(' (write error)');
			dsk2sts := NDSS_WRITERR;
			end;
		  dsksts_inv: begin
			write(' (invalid arg)');
			dsk2sts := NDSS_IVPARAM;
			end;
		  dsksts_eom: begin
			write(' (end of medium)');
			dsk2sts := NDSS_EOF;
			end;
		  dsksts_ond: begin
			write(' (no such drive)');
			dsk2sts := NDSS_NODRIVE;
			end;
		  dsksts_onh: begin
			write(' (no free handle)');
			dsk2sts := NDSS_NOROOM;
			end;
		end;
		writeln(' * ',s);
	end else
		dsk2sts := NDSS_OK;
end;

end.
